package com.learnandroid.intents;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

public class UriActivity extends Activity {
	
	private EditText txtLatitude;
	private EditText txtLongitude;
	private EditText txtPhoneNumber;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.uri_layout);
        
        //Show Location Example
        txtLatitude = (EditText) findViewById(R.id.txtLatitude);
        txtLongitude = (EditText) findViewById(R.id.txtLongitude);
        Button btnShow = (Button) findViewById(R.id.btnShowLocation);
        btnShow.setOnClickListener(new Button.OnClickListener() {
			
        @Override
		public void onClick(View v) {
			Uri location = Uri.parse("http://maps.google.com/maps?q=" 
					+ txtLatitude.getText().toString() 
					+ "," 
					+ txtLongitude.getText().toString());
			startActivity(new Intent(Intent.ACTION_VIEW, location));
		} });
        
        //Dial Phone Example
        txtPhoneNumber = (EditText) findViewById(R.id.txtPhoneNumber);
        Button btnDial = (Button) findViewById(R.id.btnDial);
        btnDial.setOnClickListener(new Button.OnClickListener() {
			
        @Override
		public void onClick(View v) {				
			Uri phoneNum = Uri.parse("tel:" + txtPhoneNumber.getText().toString());
			startActivity(new Intent(Intent.ACTION_DIAL, phoneNum));
		} });
        
        //Make Call Example
        Button btnCall = (Button) findViewById(R.id.btnCall);
        btnCall.setOnClickListener(new Button.OnClickListener() {
			
        @Override
		public void onClick(View v) {				
			Uri phoneNum = Uri.parse("tel:" + txtPhoneNumber.getText().toString());
			startActivity(new Intent(Intent.ACTION_CALL, phoneNum));
		} });
        
        //Select from Contacts Example
        Button btnContact = (Button) findViewById(R.id.btnContact);
        btnContact.setOnClickListener(new Button.OnClickListener() {
			
        @Override
		public void onClick(View v) {				
			Uri content = Uri.parse("content://contacts/people");
			startActivity(new Intent(Intent.ACTION_PICK, content));
		} });
    }
}
