package com.learnandroid.intents;

import java.util.ArrayList;
import java.util.List;

import android.app.ListActivity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.Toast;

public class UsingIntentsActivity extends ListActivity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        ListAdapter adapter = createAdapter();
        setListAdapter(adapter);
    }
    
    protected ListAdapter createAdapter()
    {
    	    	
    	List<String> tempList = new ArrayList<String>();
    	
    	Intent listIntent = new Intent("com.learnandroid.intents.VIEW_SAMPLE_CODE");
        listIntent.addCategory("com.learnandroid.intents.SAMPLE_CODE");
         
        PackageManager pm = getPackageManager();
        List<ResolveInfo> activityList = pm.queryIntentActivities(listIntent, 0);
        
        for (int i = 0; i < activityList.size(); i++) {
        	ResolveInfo info = activityList.get(i);
        	CharSequence labelChars = info.loadLabel(pm);
        	String displayName = labelChars != null ? labelChars.toString() : info.activityInfo.name;
        	tempList.add(displayName);
        }
    	
    	String[] listValues = tempList.toArray(new String[0]);
 
    	// Create a simple array adapter (of type string) with the test values
    	ListAdapter adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1
    			, listValues);
 
    	return adapter;
    }
    
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	Intent listIntent = new Intent("com.learnandroid.intents.VIEW_SAMPLE_CODE");
        listIntent.addCategory("com.learnandroid.intents.SAMPLE_CODE");
         
        PackageManager pm = getPackageManager();
        List<ResolveInfo> activityList = pm.queryIntentActivities(listIntent, 0);
                  
        ResolveInfo info = activityList.get(position);
        Intent dynamicIntent = new Intent();
        dynamicIntent.setClassName(info.activityInfo.applicationInfo.packageName, info.activityInfo.name);
        startActivityForResult(dynamicIntent, 1700 + position);
    }
    
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    	super.onActivityResult(requestCode, resultCode, data);
    	if (resultCode == RESULT_OK) {
    		Toast helloToast = Toast.makeText(this, "You Entered: " + data.getStringExtra("Name") , Toast.LENGTH_LONG);
        	helloToast.setGravity(Gravity.CENTER, 0, 0);
        	helloToast.show();
    	}
    }
}